import * as t from '@babel/types';
import { GraphQLCompositeType } from 'graphql';
import { PrintableFieldDetails, Variable } from 'graphql-tool-utilities';
import { ObjectStack } from './utilities';
import { OperationContext } from './context';
export declare function tsInterfaceBodyForObjectField({ fields }: PrintableFieldDetails, graphQLType: GraphQLCompositeType | GraphQLCompositeType[], stack: ObjectStack, context: OperationContext, requiresTypename?: boolean): t.TSInterfaceBody;
export declare function variablesInterface(variables: Variable[], context: OperationContext): t.TSInterfaceDeclaration;
//# sourceMappingURL=language.d.ts.map